## ros-foxy-rmf-traffic-editor 1.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

project(rmf_traffic_editor)

find_package(ament_cmake REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(Ceres REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(Qt5 COMPONENTS Widgets Concurrent Test REQUIRED)
find_package(yaml-cpp REQUIRED)

set(CMAKE_BUILD_TYPE RelWithDebInfo)
# set(CMAKE_VERBOSE_MAKEFILE TRUE)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wshadow -Wextra")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if(CMAKE_VERSION VERSION_LESS "3.7.0")
  set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif()

include_directories(.)
include_directories(gui)
include_directories(include)
include_directories(${ament_index_cpp_INCLUDE_DIRS})

set(gui_sources
  gui/actions/add_constraint.cpp
  gui/actions/add_edge.cpp
  gui/actions/add_feature.cpp
  gui/actions/add_fiducial.cpp
  gui/actions/add_model.cpp
  gui/actions/add_polygon.cpp
  gui/actions/add_property.cpp
  gui/actions/add_vertex.cpp
  gui/actions/delete.cpp
  gui/actions/move_feature.cpp
  gui/actions/move_fiducial.cpp
  gui/actions/move_model.cpp
  gui/actions/move_vertex.cpp
  gui/actions/polygon_remove_vertices.cpp
  gui/actions/polygon_add_vertex.cpp
  gui/actions/rotate_model.cpp
  gui/add_param_dialog.cpp
  gui/building.cpp
  gui/building_dialog.cpp
  gui/constraint.cpp
  gui/feature.cpp
  gui/edge.cpp
  gui/editor.cpp
  gui/editor_model.cpp
  gui/fiducial.cpp
  gui/graph.cpp
  gui/layer.cpp
  gui/layer_dialog.cpp
  gui/layer_table.cpp
  gui/level.cpp
  gui/level_dialog.cpp
  gui/level_table.cpp
  gui/lift.cpp
  gui/lift_dialog.cpp
  gui/lift_door.cpp
  gui/lift_table.cpp
  gui/map_view.cpp
  gui/model.cpp
  gui/model_dialog.cpp
  gui/param.cpp
  gui/polygon.cpp
  gui/preferences_dialog.cpp
  gui/preferences_keys.cpp
  gui/rendering_options.cpp
  gui/table_list.cpp
  gui/traffic_table.cpp
  gui/traffic_map.cpp
  gui/transform.cpp
  gui/vertex.cpp
  gui/yaml_utils.cpp

  #crowd_sim related
  gui/multi_select_combo_box.cpp
  gui/crowd_sim/agent_group.cpp
  gui/crowd_sim/agent_group_table.cpp
  gui/crowd_sim/agent_profile.cpp
  gui/crowd_sim/agent_profile_table.cpp
  gui/crowd_sim/condition.cpp
  gui/crowd_sim/condition_dialog.cpp
  gui/crowd_sim/crowd_sim_dialog.cpp
  gui/crowd_sim/crowd_sim_editor_table.cpp
  gui/crowd_sim/crowd_sim_impl.cpp
  gui/crowd_sim/crowd_sim_table_base.cpp
  gui/crowd_sim/goal_set.cpp
  gui/crowd_sim/goal_set_table.cpp
  gui/crowd_sim/model_type.cpp
  gui/crowd_sim/model_type_table.cpp
  gui/crowd_sim/state.cpp
  gui/crowd_sim/state_table.cpp
  gui/crowd_sim/to_state_dialog.cpp
  gui/crowd_sim/to_state_table.cpp
  gui/crowd_sim/transition.cpp
  gui/crowd_sim/transition_table.cpp
)

add_library(
  gui_lib STATIC
  ${gui_sources})

target_link_libraries(
  gui_lib
  ceres
  Eigen3::Eigen
  Qt5::Widgets
  Qt5::Concurrent
  yaml-cpp
  ${ament_index_cpp_LIBRARIES}
)

add_executable(
  traffic-editor
  resources/resource.qrc
  gui/main.cpp)

target_link_libraries(traffic-editor gui_lib)

set_property(TARGET traffic-editor PROPERTY ENABLE_EXPORTS 1)

install(
  TARGETS traffic-editor
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(
  DIRECTORY
    plugins
  DESTINATION
    include/traffic_editor)

install(
  DIRECTORY
    include/traffic_editor
  DESTINATION
    include)

if (BUILD_TESTING)
  add_subdirectory(test)
endif()

ament_export_include_directories(include)

ament_package()

=== test/CMakeLists.txt ===
add_executable(
  test_gui
  ../resources/resource.qrc
  test_gui.cpp)

target_link_libraries(
  test_gui
  gui_lib
  Qt5::Test
)

ament_add_test(
  test_gui
  COMMAND "$<TARGET_FILE:test_gui>" -o ${AMENT_TEST_RESULTS_DIR}/rmf_traffic_editor/test_gui.xml,xml -o -,txt
  OUTPUT_FILE ${AMENT_TEST_RESULTS_DIR}/rmf_traffic_editor/test_gui/output.log
)

=== debian/changelog ===
ros-foxy-rmf-traffic-editor (1.4.0-1focal) focal; urgency=high

  * Feature/graph names and widths (#384 <https://github.com/open-rmf/rmf_traffic_editor/issues/384>)
    * Graph data structure: default lane widths and a step towards #378 <https://github.com/open-rmf/rmf_traffic_editor/issues/378>
  * added support for ceilings with texture (#383 <https://github.com/open-rmf/rmf_traffic_editor/issues/383>)
  * added scaling features to wall texture (#382 <https://github.com/open-rmf/rmf_traffic_editor/issues/382>)
  * resolve build error on some systems with size_t namespace (#374 <https://github.com/open-rmf/rmf_traffic_editor/issues/374>)
    fix build error on some compilers/systems reported in https://github.com/open-rmf/rmf/discussions/85   by adding std:: prefix to size_t
  * sort list by model name, not Fuel group name (#373 <https://github.com/open-rmf/rmf_traffic_editor/issues/373>)
  * Feature: align vertices colinear (#372 <https://github.com/open-rmf/rmf_traffic_editor/issues/372>)
  * adding maintainer for buildfarm notifications (#368 <https://github.com/open-rmf/rmf_traffic_editor/issues/368>)
  * hotfix for #366 <https://github.com/open-rmf/rmf_traffic_editor/issues/366>, avoid exploding transform for 1 fudicual (#367 <https://github.com/open-rmf/rmf_traffic_editor/issues/367>)
  * Minor tweak to how empty crowd_sim and lift structures are serialized in YAML (#364 <https://github.com/open-rmf/rmf_traffic_editor/issues/364>)
  * Contributors: Marco A. Gutiérrez, Morgan Quigley, Xiyu

 -- Morgan Quigley <morgan@openrobotics.org>  Thu, 02 Sep 2021 00:00:00 -0000

ros-foxy-rmf-traffic-editor (1.3.0-1focal) focal; urgency=high

  * Feature/display layer transforms in freefleet format (#347 <https://github.com/open-rmf/rmf_traffic_editor/issues/347>)
  * Feature/layer rendering palette mapping (#344 <https://github.com/open-rmf/rmf_traffic_editor/issues/344>)
  * Fix asset path after package renaming (#341 <https://github.com/open-rmf/rmf_traffic_editor/issues/341>)
  * Automatic alignment of robot-map layers to floorplans (#340 <https://github.com/open-rmf/rmf_traffic_editor/issues/340>)
  * Fix/ci package name (#339 <https://github.com/open-rmf/rmf_traffic_editor/issues/339>)
  * clarify labels on property add/delete buttons (#326 <https://github.com/open-rmf/rmf_traffic_editor/issues/326>)
  * handle editing multiple layers with same name. (#328 <https://github.com/open-rmf/rmf_traffic_editor/issues/328>)
  * fix #324 <https://github.com/open-rmf/rmf_traffic_editor/issues/324>, update layer image immediately after OK button (#327 <https://github.com/open-rmf/rmf_traffic_editor/issues/327>)
  * Bug/add layer button not visible in new building (#313 <https://github.com/open-rmf/rmf_traffic_editor/issues/313>)
  * provide zoom-reset and clamp on scale factor (#318 <https://github.com/open-rmf/rmf_traffic_editor/issues/318>)
  * avoid crash in empty crowdsim save routine (#312 <https://github.com/open-rmf/rmf_traffic_editor/issues/312>)
  * rename building_map_tools (#310 <https://github.com/open-rmf/rmf_traffic_editor/issues/310>)
  * Rename packages and delete moved packages (#308 <https://github.com/open-rmf/rmf_traffic_editor/issues/308>)
  * Refactoring and Migration #308 https://github.com/open-rmf/rmf_traffic_editor/pull/308
  * Contributors: Geoffrey Biggs, Luca Della Vedova, Morgan Quigley, youliang

 -- Morgan Quigley <morgan@openrobotics.org>  Fri, 14 May 2021 00:00:00 -0000

ros-foxy-rmf-traffic-editor (1.2.0-1focal) focal; urgency=high

  * Adds undo capability to a large part of the actions. (#269 <https://github.com/osrf/traffic_editor/pull/269>) (#266 <https://github.com/osrf/traffic_editor/pull/266>)
  * Contibutors: Arjo, Morgan Quigley, Yadu
  * Merge pull request #276 <https://github.com/osrf/traffic_editor/issues/276> from osrf/add_lane_vertex_snap_distance_scaling
    scale add-lane vertex snap distance correctly
  * undo features
  * compute the click-to-merge treshold in pixels
  * Feature/undo: Undo for editor components (#269 <https://github.com/osrf/traffic_editor/issues/269>)
  * scale add-lane vertex snap distance correctly
  * fix to compilation when no opencv (#272 <https://github.com/osrf/traffic_editor/issues/272>)
  * Merge pull request #266 <https://github.com/osrf/traffic_editor/issues/266> from osrf/feature/undo
  * Merge branch 'feature/undo' of https://github.com/osrf/traffic_editor into feature/undo
  * Added "save" to newly updated transition entries (#265 <https://github.com/osrf/traffic_editor/issues/265>)
  * Merge pull request #263 <https://github.com/osrf/traffic_editor/issues/263> from osrf/dont_crash_on_new_project_crowdsim
  * Merge pull request #257 <https://github.com/osrf/traffic_editor/issues/257> from Briancbn/pr-fix-disable-plugin-backwards-compatibility
  * Merge pull request #255 <https://github.com/osrf/traffic_editor/issues/255> from osrf/feature/remove-plugin-option
  * Configured gui to load and save proper parameters for plugins
  * Using just the Lift object to propagate the plugin removal option
  * Added option to remove plugins for doors on gui and building_map_tools generator
  * Add GUI to traffic editor for crowd simulation configuration (#225 <https://github.com/osrf/traffic_editor/issues/225>)
  * Merge pull request #249 <https://github.com/osrf/traffic_editor/issues/249> from osrf/fix/lift_dialog_saving
  * Add first pass of quality declarations for all packages (#235 <https://github.com/osrf/traffic_editor/issues/235>)
  * Contributors: Aaron Chong, Arjo Chakravarty, Chen Bainian, Geoffrey Biggs, Guoliang (Fred) Shao, Marco A. Gutiérrez, Morgan Quigley, Tian En

 -- Morgan Quigley <morgan@openrobotics.org>  Tue, 05 Jan 2021 00:00:00 -0000

ros-foxy-rmf-traffic-editor (1.1.0-1focal) focal; urgency=high

  * Focal / Ignition dome support (#230 <https://github.com/osrf/traffic_editor/issues/230>)
  * Adding lift operation range selection (#220 <https://github.com/osrf/traffic_editor/issues/220>)


=== debian/control ===
Source: ros-foxy-rmf-traffic-editor
Section: misc
Priority: optional
Maintainer: Morgan Quigley <morgan@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libceres-dev, libeigen3-dev, libgoogle-glog-dev, libqt5concurrent5, libqt5widgets5, libyaml-cpp-dev, qtbase5-dev, ros-foxy-ament-cmake, ros-foxy-ament-index-cpp, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rmf-traffic-editor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, libgoogle-glog-dev, ros-foxy-ros-workspace
Description: traffic editor

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rmf-traffic-editor//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
